/* moncookwotl.c $Id: 7bbc3412de7e0c43b2963f557b857f9705b2aedf $ */

#include "pciaer.h"
#include "pciaerlib.h"

/******************************************************************************/

long CookWithoutTimeLabels(const int *pRaw, unsigned int nRaw, pciaer_monitor_read_ae_t *pCooked, unsigned int nToCook, unsigned int *pnUsedRaw, unsigned int *pnCooked)
{
    int i;

    *pnUsedRaw = 0;
    *pnCooked = 0;

    if ( nRaw < nToCook )
	nToCook = nRaw;

    for ( i = 0; i < nToCook; i++ )
	{
	    switch ( pRaw[ i ] & MONITOR_DWORD_TYPE_MASK )
		{
		case MONITOR_DWORD_AER_ADDR:
		    pCooked[ i ].ae = pRaw[ i ] & MONITOR_DWORD_DATA_MASK;
		    (*pnCooked)++;
		    (*pnUsedRaw)++;
		    break;
		  
		case MONITOR_DWORD_TIME_HI:
		    (*pnUsedRaw)++;
		    return PCOLERR_UNEXPECTED_TIME_HI;
		    break;

		case MONITOR_DWORD_TIME_LO:
		    (*pnUsedRaw)++;
		    return PCOLERR_UNEXPECTED_TIME_LO;
		    break;

		default: /* MONITOR_DWORD_ERROR */
		    (*pnUsedRaw)++;
		    return (long)pRaw[ i ] << (8 * sizeof(long) / 2);
		    break;
		}
	}
    return 0L;
}

/******************************************************************************/

/* EOF */
