/* seqopen.c $Id: 3cb65d4e0a33af06d92b2196c166f635bfb78b85 $ */

#include <fcntl.h>
#include <stdio.h>

#include "pciaer.h"
#include "pciaerlib.h"

extern int PciaerGetCounterPeriodFromDriver( int handle );

/******************************************************************************/

int PciaerSeqOpen(unsigned int board, int flags, int *pHandle)
{
  char pathname[20];
  int open_return;

  if ( pHandle == NULL )
	return EINVAL;

  sprintf(pathname,"/dev/aerseq%d",board);

  open_return = open( pathname, flags | O_NOCTTY );

  if (open_return < 0)
	return errno;

  *pHandle = open_return;

  /* Update the library's internal copy of the current PCI-AER board clock period */
  PciaerGetCounterPeriodFromDriver(*pHandle);

  return 0;
}

/******************************************************************************/

/* EOF */
