/* rom.h $Id: 58e5cdb0274f2cd9f5053c3e880d7fd80aed5816 $ */

#ifndef ROM_H
#define ROM_H

#define PC_EXP_ROM_SIG1			0x55
#define PC_EXP_ROM_SIG2			0xAA
#define PC_EXP_ROM_LENGTH_MULTIPLE	512
#define PC_EXP_ROM_NEAR_JUMP		0xE9
#define PC_EXP_ROM_FAR_RET		0xCB

typedef struct {
    unsigned char signature[ 2 ];
    unsigned char length;
    unsigned char entry_point[ 3 ];
    unsigned char reserved[ 18 ];
    unsigned short pci_ds_offset;
} pc_exp_rom_hdr_t;

#define PCIDS_SIGNATURE			"PCIR"
#define PCIDS_LENGTH			24
#define PCIDS_REVISION			0
#define PCIDS_IMAGE_LENGTH_MULTIPLE	512
#define PCIDS_CODE_TYPE_INTEL_X86	0x00
#define PCIDS_CODE_TYPE_OPEN_BOOT	0x01
#define PCIDS_CODE_TYPE_HP_PA_RISC	0x02
#define PCIDS_IND_LAST_IMAGE		0x80

typedef struct {
    char signature[ 4 ];
    unsigned short vendor;
    unsigned short device;
    unsigned short vpd_offset;
    unsigned short struct_length;
    unsigned char struct_revision;
    unsigned char class_code[ 3 ];
    unsigned short image_length;
    unsigned short revision_level;
    unsigned char code_type;
    unsigned char indicator;
    unsigned short reserved;
} pci_data_struct_t;

#endif
