// VpdClass.h $Id: 0b551c8619ac703ac50a5c1084271eb36f566a08 $

#include "VpdDescriptor.h"

using std::istream;
using std::ostream;

class CVitalProductData
{
 private:
    VpdIdStringDescriptor StringIdDtor;
    VpdReadOnlyDescriptor21 ReadOnlyDtor;
    VpdEndTagDescriptor21 EndTagDtor;

 public:
    istream& BinaryRead( istream& is );
    ostream& BinaryWrite( ostream& os ) const;
    bool HasIdentifier() const { return StringIdDtor.IsDefined(); }
    bool SetIdentifier( const string& id ) { return StringIdDtor.Set( id ); }
    string GetIdentifier() const { return StringIdDtor.Get(); }
    bool SetKeyword( const string& Keyword, const string& Data ) { return ReadOnlyDtor.SetKeyword( Keyword, Data ); }
    //    string GetKeyword( const string& Keyword ) const { return ReadOnlyDtor.GetKeyword( Keyword ); }
    void ForEachKeyword( void f( const string&, const string& ) ) const { return ReadOnlyDtor.ForEachKeyword( f ); }
};

inline istream& operator>>( istream& is, CVitalProductData& vpd ) { return vpd.BinaryRead( is ); }
inline ostream& operator<<( ostream& os, const CVitalProductData& vpd ) { return vpd.BinaryWrite( os ); }
