// PciaerStats.cc: class PciaerStats implementation

// PciaerStats.cc $Id: d530552fd32a5729202d128a1d447a92aa59e7b1 $


#include "PciaerStats.h"
#include <iomanip>

int PciaerStats::Reset()
{
    int error = PciaerResetStatistics( handle, StatsStructPtr() );

    if ( !error )
	{
	    words_transferred = 0;
	    user_transfers = 0;
	    total_interrupts = 0;
	    overflows_underflows = 0;
	    timeouts = 0;
	}

    return error;
}

ostream& operator<<( ostream& os, const PciaerStats& ps )
{
    using std::setw;
    using std::setfill;

    os << '\t' << setw( 10 ) << ps.words_transferred << " words transferred\n"
       << '\t' << setw( 10 ) << ps.user_transfers << " user transfers\n"
       << '\t' << setw( 10 ) << ps.total_interrupts << " total interrupts\n"
       << '\t' << setw( 10 ) << ps.overflows_underflows << " overflows or underflows\n"
       << '\t' << setw( 10 ) << ps.timeouts << " timeouts\n"
       << '\t' << setw( 10 ) << ps.memory_usage << " bytes of memory in use\n"
       << "\ttimestamp [" << ps.timestamp.tv_sec << '.' << setw( 6 ) << setfill( '0' ) << ps.timestamp.tv_usec << "]\n"
       << setw( 8 ) << setfill( ' ' );
    return os;
}
