// PciaerStats.h: class PciaerStats

// PciaerStats.h $Id: 23f295201dc8065075ee0026566dd34682f2d83b $

extern "C" {
#include "pciaer.h"
#include "pciaerlib.h"
}

#include <ostream>

using std::ostream;

class PciaerStats : protected pciaer_stats_t_2
{
 protected:
    int handle;

 public:
    PciaerStats() : handle( -1 ) { size = sizeof(pciaer_stats_t_2); }
    PciaerStats( int h ) : handle( h ) { size = sizeof(pciaer_stats_t_2); }

    int Refresh()
        { return PciaerGetStatistics( handle, StatsStructPtr() ); }
    int Reset();
    int RefreshAndReset()
        { return PciaerResetStatistics( handle, StatsStructPtr() ); }

    unsigned long GetWordsTransferred() const { return words_transferred; }
    unsigned long GetUserTransfers() const { return user_transfers; }
    unsigned long GetTotalInterrupts() const { return total_interrupts; }
    unsigned long GetOverOrUnderFlows() const { return overflows_underflows; }
    unsigned long GetTimeouts() const { return timeouts; }
    unsigned long GetMemoryUsage() const { return memory_usage; }
    const struct timeval & GetTimestamp() const { return timestamp; }

    friend ostream& operator<<( ostream& os, const PciaerStats& ps );

  protected:
    pciaer_stats_t* StatsStructPtr()
        { return reinterpret_cast<pciaer_stats_t*>(dynamic_cast<pciaer_stats_t_2*>(this)); }
};

ostream& operator<<( ostream& os, const PciaerStats& ps );
