// testcntr.c - TestCounter function used by both testmon & testseq.

// testcntr.c $Id: d8d6e404634fbefcaa95d012e9c1aa6a7f417b67 $

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/time.h>

#include "pciaer.h"

void TestCounter( int handle )
{
    int counter_period;
    struct timeval tv;

    if ( ioctl( handle, PCIAER_IOC_GET_CNTR_PERIOD, &counter_period ) != 0 )
    {
	perror( "PCIAER_IOC_GET_CNTR_PERIOD" );
	exit( 1 );
    }
    printf( "Counter period = %dus\n", counter_period );

    if ( ioctl( handle, PCIAER_IOC_RST_CNTR_GET_TIME, NULL ) != 0 )
    {
	perror( "PCIAER_IOC_RST_CNTR_GET_TIME" );
	exit( 1 );
    }
    printf( "Counter reset\n" );

    if ( ioctl( handle, PCIAER_IOC_RST_CNTR_GET_TIME, &tv ) != 0 )
    {
	perror( "PCIAER_IOC_RST_CNTR_GET_TIME" );
	exit( 1 );
    }
    printf( "Counter reset at           %ld.%06ld\nSleeping ~1s...\n", tv.tv_sec, tv.tv_usec );
    sleep( 1 );
    gettimeofday( &tv, NULL );
    printf( "Time after sleeping is now %ld.%06ld\n", tv.tv_sec, tv.tv_usec );

    if ( ioctl( handle, PCIAER_IOC_GET_CNTR_LAST_RST_TIME, &tv ) != 0 )
    {
	perror( "PCIAER_IOC_GET_CNTR_LAST_RST_TIME" );
	exit( 1 );
    }
    printf( "Counter was last reset at  %ld.%06ld\n", tv.tv_sec, tv.tv_usec );
}
